/* Copyright 2007 Brendan Halpin brendan.halpin@ul.ie
   Distribution is permitted under the terms of the GNU General Public Licence
*/
#delimit ;
mata:;

function hamming (string vl, string sm, string rh) {
subsmat=st_matrix(sm);
st_view(data=.,.,(tokens(vl)));
maxwidth=cols(data);
nobs = rows(data);
resmat = J(nobs,nobs,0);


for (i=1;i<=nobs;i++) {
  for (j=i;j<=nobs;j++) {
    resmat[i,j]=hammingdistance(i,j,data,subsmat,maxwidth);
  }
}

resmat = resmat + resmat';
st_matrix(rh,resmat);

}

function hammingdistance (real scalar first, real scalar second, real matrix data, real matrix subsmat, real scalar maxwidth) {
  real scalar hammingdistance, i;
hammingdistance=0;
for (i=1;i<=maxwidth;i++) {
hammingdistance=hammingdistance+subsmat[data[first,i],data[second,i]];
}
return(hammingdistance/maxwidth);

}

end

program define hamming;
version 9;
   syntax varlist , SUBSmat(string) PWDist(string);
mata hamming("`varlist'","`subsmat'","`pwdist'");
end;
